package	jp.co.sds_corp.hibiya.monitor;

import java.awt.Dialog;
import java.awt.Font;
import java.awt.Frame;
import java.text.DecimalFormat;
import java.util.ResourceBundle;

import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;

import jp.co.sds_corp.util.common.CmnManifest;
import jp.co.sds_corp.util.window.WindowUtility;

public class AboutDialog extends JDialog
{
	private static final long serialVersionUID = 1L;
	static String mankey = "jp/co/sds_corp/hibiya/monitor/";
	String title;
	String version;
	JOptionPane	pane;
	JLabel		lbl;
	ResourceBundle	res;

	protected AboutDialog( Frame parent ) {
		super( parent, true );
	}

	protected AboutDialog( Dialog parent ) {
		super( parent, true );
	}

	private void createControl() {
		res = ResourceBundle.getBundle( "resource.monitor" );
		lbl = createLabel();
		pane = new JOptionPane( lbl,
			JOptionPane.INFORMATION_MESSAGE, JOptionPane.DEFAULT_OPTION );
		setContentPane( pane );
		WindowUtility.setHideOnEscape( this );

		pack();
	}

	private JLabel createLabel() {
		try {
			CmnManifest mn = new CmnManifest( getClass() );
			title = mn.getTitle( mankey );
			version = mn.getVersion( mankey );
		} catch ( Exception e ) {
			e.printStackTrace();
		}

		DecimalFormat df = new DecimalFormat( "#,###" );
		Runtime rt = Runtime.getRuntime();
		String html =
			"<HTML>"
			+ title + " ver. " + version + "<BR>"
			+ "<BR>"
			+ "Copyright (C) 1995-2009 S.D.S. all rights reserved.<BR>"
			+ "<A HREF='http://www.sds-corp.co.jp/'>http://www.sds-corp.co.jp/</A><BR>"
			+ "<BR><HR color='gray'>"
			+ "maxMemory=" + df.format( rt.maxMemory() ) + "<BR>"
			+ "totalMemory=" + df.format( rt.totalMemory() ) + "<BR>"
			+ "freeMemory=" + df.format( rt.freeMemory() ) + "<BR>"
			+ "</HTML>";

		JLabel lbl = new JLabel( html );
		// lbl.setFont( getFont() );
		return lbl;
	}

	public void setFont( Font f ) {
		super.setFont( f );
	}

	public void setVisible( boolean var ) {
		if ( var ) {
			createControl();
			pane.setValue( Integer.valueOf( -1 ));
			String text;
			text = res.getString( "about.title" );
			JDialog dlg = pane.createDialog( getParent(), text );
			dlg.setVisible( var );
		}
	}

	public void showHelp() {
		DecimalFormat df = new DecimalFormat( "#,###" );
		Runtime rt = Runtime.getRuntime();
		String html =
			"<HTML>"
			+ title + " ver. " + version + "<BR>"
			+ "<BR>"
			+ "Copyright (C) 1995-2009 S.D.S. all rights reserved.<BR>"
			+ "<A HREF='http://www.sds-corp.co.jp/'>http://www.sds-corp.co.jp/</A><BR>"
			+ "<HR color='gray'><BR>"
			+ "maxMemory=" + df.format( rt.maxMemory() ) + "<BR>"
			+ "totalMemory=" + df.format( rt.totalMemory() ) + "<BR>"
			+ "freeMemory=" + df.format( rt.freeMemory() ) + "<BR>"
			+ "</HTML>";
		JLabel lbl = new JLabel( html );
		JOptionPane.showMessageDialog( this,
			lbl,
			"Hibiya Monitorについて",
			JOptionPane.INFORMATION_MESSAGE );
	}

}
