package jp.co.sds_corp.hibiya.monitor;

import java.awt.Dialog;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import java.util.Vector;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;

import jp.co.sds_corp.hibiya.server.CheckerChangeEvent;
import jp.co.sds_corp.hibiya.server.IChecker;
import jp.co.sds_corp.hibiya.server.ICheckerListener;
import jp.co.sds_corp.util.window.WindowUtility;

/**
* {@link IChecker}の履歴を一覧表示するダイアログです。
*/
public class HistoryDialog extends JDialog implements ICheckerListener
{
	private static final long serialVersionUID = 1L;
	JButton BTN_OK = new JButton( "OK" );

	SetupParam		setup;
	HistoryPanel	panel;
	ResourceBundle	res;
	Vector<CheckerChangeEvent>	vecHist;

	public HistoryDialog( Frame parent, SetupParam setup, Vector<CheckerChangeEvent> vec ) {
		super( parent );
		this.setup = setup;
		this.vecHist = vec;
		createControls();
	}

	public HistoryDialog( Dialog parent, SetupParam setup, Vector<CheckerChangeEvent> vec ) {
		super( parent );
		this.setup = setup;
		this.vecHist = vec;
		createControls();
	}

	private void createControls() {
		res = ResourceBundle.getBundle( "resource.monitor" );
		setModal( true );
		setResizable( false );
		String title = res.getString( "history.title" );
		setTitle( title );
		setSize( 477, 421 );
		getContentPane().setLayout( new BoxLayout(
							getContentPane(), BoxLayout.Y_AXIS ));
		Font	f = setup.getFont();
		setFont( f );
		WindowUtility.setHideOnEscape( this );

		panel = new HistoryPanel( (Window )getParent(), setup, vecHist );
		panel.setHistoryList( vecHist );
		getContentPane().add( panel );

		Box box1 = new Box( BoxLayout.X_AXIS );
		box1.add( BTN_OK );
		getContentPane().add( box1 );
		getRootPane().setDefaultButton( BTN_OK );

		BTN_OK.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				onOk();
			}
		});
	}

	/**
	* ICheckerの状態に変更があった場合に呼び出されます。
	* @param    ev      状態の変更内容を指定します。
	*/
	public void checkerChanged( CheckerChangeEvent ev ) throws Exception {
		panel.checkerChanged( ev );
	}

	public void onOk() {
		setVisible( false );
	}

}
