package	jp.co.sds_corp.hibiya.monitor;

import java.awt.Dimension;
import java.awt.Window;
import java.util.ResourceBundle;

import javax.swing.BoxLayout;
import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import jp.co.sds_corp.hibiya.server.IChecker;
import jp.co.sds_corp.hibiya.threshold.ScriptThreshold;

/**
* {@link IChecker}のイベントの条件を表示します。
*/
public class ThresholdPanel extends JPanel
{
	private static final long serialVersionUID = 1L;
	Window			owner;
	SetupParam		setup;
	IChecker		checker;	// checker

	ResourceBundle	res;
	IChecker		chk;
	JComboBox		CMB_TYPE;
	JTextField		TXT_KEY;
	JTextArea		TXT_SCRIPT;
	String[]		types = {
		"JavaScript"
	};

	public ThresholdPanel( Window owner, SetupParam setup ) {
		this.owner = owner;
		this.setup = setup;
		createControls();
	}

	protected void createControls() {
		res = ResourceBundle.getBundle( "resource.monitor" );
		setLayout( new BoxLayout( this, BoxLayout.Y_AXIS ));

		JPanel panel = new JPanel() { 
			private static final long serialVersionUID = 1L;

			public Dimension getMaximumSize() { 
				return new Dimension(
					super.getMaximumSize().width, getPreferredSize().height);
			} 
		}; 
		panel.setLayout( new BoxLayout( panel, BoxLayout.X_AXIS ));
		CMB_TYPE = new JComboBox( types );
		CMB_TYPE.setEnabled( false );
		panel.add( CMB_TYPE );
/*
		panel.add( Box.createHorizontalStrut( 30 ) );
		panel.add( new JLabel( "Key:" ));
		TXT_KEY = new JTextField( 30 );
		panel.add( TXT_KEY );
		panel.add( Box.createHorizontalGlue() );
*/
		add( panel );
		TXT_SCRIPT = new JTextArea( 5, 30 );
		JScrollPane sp = new JScrollPane( TXT_SCRIPT );
		add( sp );
	}

	/**
	* checkerを設定します。
	* @param	var		設定するデータ
	*/
	public void setupChecker( IChecker var ) {
		ScriptThreshold thr = (ScriptThreshold )var.getThreshold();
		if ( thr != null  ) {
			thr.setScript( TXT_SCRIPT.getText());
		}
	}
	/**
	* checkerを設定します。
	* @param	var		設定するデータ
	*/
	public void setChecker( IChecker var ) {
		this.checker = var;
		TXT_SCRIPT.setText( null );
		ScriptThreshold thr = (ScriptThreshold )var.getThreshold();
		if ( thr != null ) {
			TXT_SCRIPT.setText( thr.getScript() );
		} else {
			TXT_SCRIPT.setEnabled( false );
		}
		TXT_SCRIPT.setCaretPosition( 0 );
	}
	/**
	* checkerを取得します。
	* @return	checker
	*/
	public IChecker getChecker() {
		return checker;
	}

	/**
	* スクリプトを取得します。
	* @return	スクリプト
	*/
	public String getScript() {
		return TXT_SCRIPT.getText();
	}

	public void setEnabled( boolean bEn ) {
		// CMB_TYPE.setEnabled( bEn );
		// TXT_KEY.setEnabled( bEn );
		// TXT_SCRIPT.setEditable( bEn );
		TXT_SCRIPT.setEnabled( bEn );
	}

}
