package	jp.co.sds_corp.hibiya.monitor.connector;

import java.util.ResourceBundle;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JCheckBox;
import javax.swing.JPanel;

import jp.co.sds_corp.hibiya.connector.IConnector;
import jp.co.sds_corp.util.window.ValuePanel;

/**
* {@link IConnector}の各種設定をするPanelのための基底クラスです。
* @author	小見山　聡
*/
public abstract class AbstractPanel extends JPanel implements IConnectorPanel
{
	private static final long serialVersionUID = 1L;
	ResourceBundle	res;
	IConnector	connector;
	ValuePanel	VAL_NAME;
	ValuePanel	VAL_INT;
	JCheckBox	CHK_BLANK;
	Box			PNL_BLANK = new Box( BoxLayout.X_AXIS );

	AbstractPanel() {
		res = ResourceBundle.getBundle( "resource.monitor" );
		String text;
		text = res.getString( "connector.name.text" );
		VAL_NAME = new ValuePanel( ValuePanel.ReturnType.STRING, text );
		text = res.getString( "connector.rmi.interval.text" );
		VAL_INT = new ValuePanel( ValuePanel.ReturnType.INT, text );
		text = res.getString( "connector.blank.text" );
		CHK_BLANK = new JCheckBox( text );
		PNL_BLANK.add( CHK_BLANK );
		PNL_BLANK.add( Box.createHorizontalGlue() );
	}

	/**
	* {@link IConnector}を設定します。
	*/
	public void setConnector( IConnector connector ) {
		this.connector = connector;
		VAL_NAME.setValue( connector.getName() );
		VAL_INT.setValue( String.valueOf( connector.getCheckInterval() ));
		CHK_BLANK.setSelected( connector.isDisplayOnBlank());
	}

	/**
	* {@link IConnector}を取得します。
	*/
	public IConnector getConnector() {
		return connector;
	}

	public void clear() {
		VAL_NAME.setValue( null );
		VAL_INT.setValue( null );
		CHK_BLANK.setSelected( true );
	}

	public void updateConnector() throws Exception {
		connector.setName( (String )VAL_NAME.getValue() );
		connector.setCheckInterval( ((Integer )VAL_INT.getValue()).intValue() );
		connector.setDisplayOnBlank( CHK_BLANK.isSelected());
	}

	public void setEnabled( boolean bEn ) {
		super.setEnabled( bEn );
		VAL_INT.setEnabled( bEn );
		CHK_BLANK.setEnabled( bEn );
	}

}

