package	jp.co.sds_corp.hibiya.monitor.connector;

import jp.co.sds_corp.hibiya.connector.IConnector;

/**
* {@link IConnector}の各種設定をするPanelのためのインターフェースです。
* @author	小見山　聡
*/
public interface IConnectorPanel
{
	/**
	* {@link IConnector}を設定します。
	*/
	public void setConnector( IConnector action );
	/**
	* {@link IConnector}を取得します。
	*/
	public IConnector getConnector();

	/**
	* 現在の{@link IConnector}を入力された内容で設定します。
	*/
	public void updateConnector() throws Exception;

	/**
	* 設定内容をクリアします。
	*/
	public void clear();

	/**
	* このパネルが有効かどうかを設定します。
	* @param	bChk	有効にする場合true　無効にする場合false
	*/
	public void setEnabled( boolean bChk );
}
